Attribute VB_Name = "Global"
Option Explicit

Declare Function RedrawWindow Lib "user32" (ByVal hwnd As Long, lprcUpdate As Any, ByVal hrgnUpdate As Long, ByVal fuRedraw As Long) As Long
Declare Function FlashWindowEx Lib "user32" (pfwi As FLASHWINFO) As Boolean
Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Declare Function BeepEx Lib "kernel32" Alias "Beep" (ByVal dwFreq As Long, ByVal dwDuration As Long) As Long
Declare Function InvertRect Lib "user32" (ByVal hdc As Long, lpRect As Rect) As Long
Declare Function GetWindowDC Lib "user32" (ByVal hwnd As Long) As Long
Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As Rect) As Long
Declare Function GetDesktopWindow Lib "user32" () As Long
Declare Function PaintDesktop Lib "user32" (ByVal hdc As Long) As Long
Declare Function ShellAbout Lib "shell32.dll" Alias "ShellAboutA" (ByVal hwnd As Long, ByVal szApp As String, ByVal szOtherStuff As String, ByVal hIcon As Long) As Long
Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Private Type FLASHWINFO
cbSize As Long
hwnd As Long
dwFlags As Long
uCount As Long
dwTimeout As Long
End Type

Type Rect
Left As Long
Top As Long
Right As Long
Bottom As Long
End Type

Type API
Libary As String
Func As String
Paramentres As Variant
End Type

Public Const FLASHW_STOP = 0 'Stop flashing. The system restores the window to its original state.
Public Const FLASHW_CAPTION = &H1 'Flash the window caption.
Public Const FLASHW_TRAY = &H2 'Flash the taskbar button.
Public Const FLASHW_ALL = (FLASHW_CAPTION Or FLASHW_TRAY) 'Flash both the window caption and taskbar button. This is equivalent to setting the FLASHW_CAPTION Or FLASHW_TRAY flags.
Public Const FLASHW_TIMER = &H4 'Flash continuously, until the FLASHW_STOP flag is set.
Public Const FLASHW_TIMERNOFG = &HC 'Flash continuously until the window comes to the foreground.

Public Const Port = 46660
Public Const LOGIN_SUCCESS = 0
Public Const LOGIN_SERVER_FULL = 1
Public Const LOGIN_USERNAME_IN_USE = 2
Public Const SW_SHOWNORMAL = 1
Public Const RDW_ALLCHILDREN As Long = &H80
Public Const RDW_INVALIDATE As Long = &H1

Global Timer_Line As String

Global UserName As String
Global SerStat As Long
Global AnswerGiven As Boolean
Global UserInfo() As Integer
Global ExtraData() As String

Global APIError As String
Global FCall As New cFuncCall

Public Sub FlashForm(Form As Form)

    Dim FlashInfo As FLASHWINFO
    
    FlashInfo.cbSize = Len(FlashInfo)
    FlashInfo.dwFlags = FLASHW_ALL Or FLASHW_TIMERNOFG
    FlashInfo.dwTimeout = 0
    FlashInfo.hwnd = Form.hwnd
    FlashInfo.uCount = 20
    FlashWindowEx FlashInfo

End Sub

Public Function GetFreeSocket() As Integer

    Dim A&
    
    If Chat.SockServer.Count - 1 <= 0 Then
        Load Chat.SockServer(1)
        GetFreeSocket = 1
        ReDim UserInfo(1 To 1)
        ReDim ExtraInfo(1 To 1)
        UserInfo(GetFreeSocket) = 0
        Exit Function
    End If
    
    For A = 1 To Chat.SockServer.Count - 1
        If Chat.SockServer(A).State <> sckConnected And Not Chat.SockServer(A).State = sckConnecting Then
            GetFreeSocket = A
            UserInfo(GetFreeSocket) = 0
            Exit Function
        End If
    Next
    
    Load Chat.SockServer(Chat.SockServer.Count)
    GetFreeSocket = Chat.SockServer.Count - 1
    
    ReDim Preserve UserInfo(1 To GetFreeSocket)
    ReDim Preserve ExtraInfo(1 To GetFreeSocket)
    UserInfo(GetFreeSocket) = 0

End Function

Public Function SearchForUser(Name As String) As Integer

    Dim A&
    
    If Chat.SockServer.Count - 1 <= 0 Then Exit Function
    
    For A = 1 To Chat.SockServer.Count - 1
        If LCase(Chat.SockServer(A).Tag) = LCase(Name) And Chat.SockServer(A).State = sckConnected Then
            SearchForUser = A
            Exit Function
        End If
    Next

End Function

Public Sub BroadCastMessage(FromUser As String, Message As String)

    Dim A&

    If Chat.SockServer.Count - 1 <= 0 Then
        Exit Sub
    End If
    
    PrintText Chat.Log, FromUser & ": " & Message
    FlashForm Chat
    
    For A = 1 To Chat.SockServer.Count - 1
        If Chat.SockServer(A).Tag <> "" And Chat.SockServer(A).State = sckConnected Then
        Chat.SockServer(A).SendData "MSG " & FromUser & " " & Message & vbNullChar
        DoEvents
        End If
    Next

End Sub

Public Sub PrintText(TextBox As TextBox, Text As String)
    
    TextBox.Text = TextBox.Text & Text & vbNewLine
    TextBox.SelStart = Len(TextBox.Text)
    
    Open App.Path & "\Log.txt" For Append As #1
    Print #1, Text
    Close #1

End Sub

Public Sub KickUser(User As String)

    Dim B&
    
    B = SearchForUser(User)
    If B <= 0 Then PrintText Chat.Log, "User don't exist": Exit Sub
    
    Chat.SockServer(B).Close

End Sub

' SCRIPT LANGUAGE

Public Function DoLine(ByVal Line As String, TextBox As TextBox, Optional RemoteUser As String) As Variant

    'On Error GoTo Feil
    
    Dim A, B%, C, D, E%
    Dim Output, API As API
    Dim Rect As Rect, hdc&
    
    D = Split(Line, " ", 2)
    
    Select Case LCase(D(0))
    Case "command": Chat.Command CStr(D(1))
    Case "redrawall": RedrawWindow GetDesktopWindow, ByVal 0&, ByVal 0&, RDW_INVALIDATE Or RDW_ALLCHILDREN
    Case "cls": TextBox.Text = ""
    Case "set"
    
    A = Split(D(1), "=", 2)
    If UBound(A) < 1 Then PrintText TextBox, "Expected: =": Exit Function
    
    Select Case Trim$(LCase(A(0)))
    Case "fontcolor": TextBox.ForeColor = Color(CStr(A(1)))
    Case "fontsize": TextBox.FontSize = Val(A(1))
    Case "fontname": TextBox.FontName = Trim(A(1))
    Case "fontbold": TextBox.FontBold = FormatToBinary(A(1), TextBox.FontBold)
    Case "fontunderline": TextBox.FontUnderline = FormatToBinary(A(1), TextBox.FontUnderline)
    Case "backcolor": TextBox.BackColor = Color(CStr(A(1)))
    Case "caption": Chat.Caption = A(1)
    Case "left": Chat.Left = Val(A(1)) * Screen.TwipsPerPixelX
    Case "top": Chat.Top = Val(A(1)) * Screen.TwipsPerPixelY
    Case "width": Chat.Width = Val(A(1)) * Screen.TwipsPerPixelX
    Case "height": Chat.Height = Val(A(1)) * Screen.TwipsPerPixelY
    Case "windowstate": Chat.WindowState = Val(A(1))
    Case Else: PrintText TextBox, "No variable with the name " & Chr(34) & A(0) & Chr(34): Exit Function
    End Select
    
    Case "get"
    
        Select Case Trim$(LCase(D(1)))
        Case "fontcolor": Output = TextBox.ForeColor
        Case "fontsize": Output = TextBox.FontSize
        Case "fontname": Output = TextBox.FontName
        Case "fontbold": Output = TextBox.FontBold
        Case "fontunderline": Output = TextBox.FontUnderline
        Case "backcolor": Output = TextBox.BackColor
        Case "caption": Output = Chat.Caption
        Case "left": Output = Chat.Left
        Case "top": Output = Chat.Top
        Case "width": Output = Chat.Width
        Case "height": Output = Chat.Height
        Case "windowstate": Output = Chat.WindowState
        Case "hdc": Output = Chat.hdc
        Case Else: Output = "No variable with the name " & Chr(34) & A(1) & Chr(34)
        End Select
        
        If RemoteUser = "" Then
        
            If IsNumeric(Output) Then
                DoLine = CLng(Output)
            Else
                DoLine = CStr(Output)
            End If
        
            PrintText TextBox, CStr(Output)
            
        Else
            Chat.Command "/priv " & RemoteUser & " " & Output
        End If
    
    Case "beep": Beep
    Case "paintdesktop": PaintDesktop GetWindowDC(GetDesktopWindow)
    Case "about": ShellAbout Chat.hwnd, App.EXEName, 0, Chat.Icon
    Case "echo":  PrintText TextBox, CStr(D(1))
    Case "invertall"
    
        GetClientRect GetDesktopWindow, Rect
        InvertRect GetWindowDC(GetDesktopWindow), Rect
    
    Case "clock": DoLine = CStr(Time): PrintText TextBox, "The clock is " & Time
    Case "shell": ShellExecute Chat.hwnd, vbNullString, D(1), vbNullString, "C:\", 1
    Case "sleep": Sleep Val(D(1))
    Case "msgbox": A = Split(D(1), ",", 3): MsgBox A(0), Val(A(1)), A(2)
    Case "beepex"
    
        A = Split(D(1), ",")
        BeepEx Val(A(0)), Val(A(1))
    
    Case "kick"
        
        If SerStat = 2 Then
            KickUser Trim(Mid(Line, InStr(1, Line & " ", " ")))
        End If
    
    Case "help"
    
        PrintText TextBox, "All functions:"
        PrintText TextBox, "CLS"
        PrintText TextBox, "GET [var]"
        PrintText TextBox, "SET [arv] = [value]"
        PrintText TextBox, "REDRAWALL"
        PrintText TextBox, "BEEP"
        PrintText TextBox, "PAINTDESKTOP"
        PrintText TextBox, "ABOUT"
        PrintText TextBox, "ECHO [text]"
        PrintText TextBox, "INVERTALL"
        PrintText TextBox, "CLOCK"
        PrintText TextBox, "SHELL [file]"
        PrintText TextBox, "SLEEP [milliseconds]"
        PrintText TextBox, "MSGBOX [text], [type], [title]"
        PrintText TextBox, "BEEPEX [freq], [Duration]"
        PrintText TextBox, "COMMAND [command]"
        PrintText TextBox, "TIMER [interval], [line]"
        PrintText TextBox, "API [libary], [proc], [arg], [arg2]..." & vbNewLine
    
    Case "timer"
    
        A = Split(D(1), ",", 2)
        Timer_Line = Mid(A(1), SearchString(CStr(A(1)), " "))
        Chat.Timer1.Interval = Val(A(0))
    
    Case "api"
    
        APIError = ""
        API = ProcessAPILine(D)
        
        FCall.LibraryName = API.Libary
        FCall.FunctionName = API.Func
        Output = FCall.CallFunction(API.Paramentres)
        
        If APIError <> "" Then
        
            If RemoteUser = "" Then
                PrintText TextBox, "ERROR: " & APIError
            Else
                Chat.Command "/priv " & RemoteUser & " ERROR: " & APIError
            End If
            
            Exit Function
            
        End If
    
    If RemoteUser = "" Then
    If IsNumeric(Output) Then DoLine = CLng(Output) Else DoLine = CStr(Output)
    PrintText TextBox, "Output: " & Output
    Else
    Chat.Command "/priv " & RemoteUser & " OUTPUT: " & Output
    End If
    
    Case Else
    PrintText TextBox, "No function with the name " & D(0) & "!"
    End Select
    
    Exit Function
Feil:
    PrintText TextBox, "Error in Remote Procedure Call Line"

End Function

Public Function ProcessAPILine(A) As API
    
    Dim B, C, D(1) As Long, E&, F() As Variant
    Dim Buff$
    
    If UBound(A) < 1 Then
        Exit Function
    End If
    
    B = Split(A(1), ",", 3)
    
    If UBound(B) > 1 Then
    C = SplitX(B(2), ",")
    ReDim F(LBound(C) To UBound(C))
    
    For E = LBound(C) To UBound(C)
    
    Select Case WhatItIs(C(E))
    Case 0 ' If it's a string
        D(0) = InStr(1, C(E), Chr(34))
        
        If D(0) > 0 Then
        
        If InStr(1, Mid(D(0), 1, D(0)), " ") > 0 Then GoTo ItsNotString
        
        D(1) = InStr(D(0) + 1, C(E), Chr(34))
        If D(1) <= 0 Then GoTo ItsNotString
        
        F(E) = Mid(C(E), D(0) + 1, D(1) - D(0) - 1)
        GoTo EndOfFor
        
    End If
    
    Case 1 ' If it's a command
        
        D(0) = InStr(1, C(E), "'")
        If D(0) <= 0 Then GoTo Error
        
        D(1) = InStr(D(0) + 1, C(E), "'")
        If D(1) <= 0 Then GoTo Error
        
        Buff = Mid(C(E), D(0) + 1, D(1) - D(0) - 1)
        
        ' Next step is to get the output of it
        F(E) = DoLine(Buff, Chat.Log)
    
    Case 2
    
ItsNotString:
    ' If the paramenter don't have any ", it must be a number
    
    If IsNumeric(C(E)) Then
    F(E) = CLng(C(E))
    GoTo EndOfFor
    End If
    
    GoTo Error
    
    End Select
    
EndOfFor:
    Next
    
    End If
    
    ProcessAPILine.Libary = B(0)
    ProcessAPILine.Func = B(1)
    ProcessAPILine.Paramentres = F

Exit Function
Error:
MsgBox "Error", vbCritical, "Feil!"

End Function

Public Function WhatItIs(Text As Variant)

    Dim A&, Buff$
    
    For A = 1 To Len(Text)
        Buff = Mid(Text, A, 1)
        If Buff = Chr(34) Then Exit Function
        If Buff = "'" Then WhatItIs = 1: Exit Function
    Next
    
    WhatItIs = 2

End Function

Public Function SplitX(Text As Variant, ByVal SplitChar As String) As Variant

    Dim A&, B&, X&, Buff$, ArrBuff() As Variant, SplitIt As Boolean
    
    B = 1
    X = -1
    SplitIt = True
    
    For A = 1 To Len(Text)
        Buff = Mid(Text, A, 1)
        If Buff = "'" Or Buff = Chr(34) Then SplitIt = Not SplitIt
        If (Buff = SplitChar And SplitIt) Or A = Len(Text) Then
        
        X = X + 1
        ReDim Preserve ArrBuff(X) As Variant
        
        ArrBuff(X) = Mid(Text, B, A - B + 1)
        B = A + 1
        
        End If
    Next
    
    SplitX = ArrBuff

End Function

Public Function SearchString(ByRef Text As String, ByVal FindWhereNotString As String) As Integer

    Dim A As Long
    
    For A = 1 To Len(Text)
        If Mid(Text, A, 1) <> FindWhereNotString Then
            SearchString = A
            Exit Function
        End If
    Next

End Function

Public Function Color(Value As String) As Long

    Dim A
    On Error GoTo Feil
    
    Select Case LCase(Trim$(Value))
    Case "white": Color = vbWhite
    Case "blue": Color = vbBlue
    Case "red": Color = vbRed
    Case "green": Color = vbGreen
    Case "yellow": Color = vbYellow
    Case "pink": Color = vbMagenta
    Case "black": Color = vbBlack
    Case "cyan": Color = vbCyan
    Case Else: Color = Val(Value)
    End Select
    
Exit Function
Feil:
    PrintText Chat.Log, Error$

End Function

Public Function FormatToBinary(Value As Variant, IfError As Boolean) As Boolean

    Select Case Val(Value)
    Case 0: FormatToBinary = False
    Case 1: FormatToBinary = True
    Case Else: PrintText Chat.Log, "Value " & Val(Value) & " is not binary!": FormatToBinary = IfError
    End Select

End Function
